package com.brilliance.isc.mda.dao;

import com.brilliance.isc.vo.manager.GtxManageVo;
import com.brilliance.isc.vo.manager.PtyManageVo;
import org.apache.ibatis.annotations.Mapper;
import com.brilliance.isc.bo.Gtx;
import com.brilliance.isc.vo.manager.GtxManageVo;
import org.apache.ibatis.annotations.Param;

import java.util.Collection;
import java.util.Map;
import java.util.List;

@Mapper
public interface GtxMapper {


    Gtx queryById(@Param("inr") String inr);

    /**
     * 通过ID查询单条数据
     *
     * @param extkey
     * @return 实例对象
     */
    Gtx queryByExtkey(@Param("extkey") String extkey);


    /**
     * 查询指定行数据
     *
     * @param gtx 查询条件
     * @return 对象列表
     */
    List<Gtx> queryAllByLimit(Gtx gtx);

    List<GtxManageVo> queryAllByLimit1(GtxManageVo gtxManageVo);

//    /**
//     * 统计总行数
//     *
//     * @param gtx 查询条件
//     * @return 总行数
//     */
//    long count(Gtx gtx);

    /**
     * 新增数据
     *
     * @param gtx 实例对象
     * @return 影响行数
     */
    int insert( Gtx gtx);

    /**
     * 批量新增数据（MyBatis原生foreach方法）
     *
     * @param entities List<Gtx> 实例对象列表
     * @return 影响行数
     */
    int insertBatch(@Param("entities") List<Gtx> entities);

    /**
     * 批量新增或按主键更新数据（MyBatis原生foreach方法）
     *
     * @param entities List<Gtx> 实例对象列表
     * @return 影响行数
     * @throws org.springframework.jdbc.BadSqlGrammarException 入参是空List的时候会抛SQL语句错误的异常，请自行校验入参
     */
    int insertOrUpdateBatch(@Param("entities") List<Gtx> entities);

    /**
     * 修改数据
     *
     * @param gtx 实例对象
     * @return 影响行数
     */
    int update(Gtx gtx);

    /**
     * 通过主键删除数据
     *
     * @param  inr
     * @return 影响行数
     */
    int deleteById(@Param("inr") String inr );

    /**
     * 通过主键inr查询ver版本号信息
     *
     * @param inr
     * @return 影响行数
     */
    String getVersionByInr(@Param("inr")String inr);

    Gtx selectByPrimaryKey(Gtx record);

    List<Gtx> selectList(Gtx gtx);

    String getInrByExtkey(String extkey);

    Gtx selectInDirectSwiAdd();

    List<PtyManageVo> listAccPty(GtxManageVo gtxManageVo);

    List<Gtx> selectBeginAndEndData();
}

